package com.storlead.util;

import com.alibaba.fastjson.JSON;
import com.aliyuncs.DefaultAcsClient;
import com.aliyuncs.IAcsClient;
import com.aliyuncs.dysmsapi.model.v20170525.SendSmsRequest;
import com.aliyuncs.dysmsapi.model.v20170525.SendSmsResponse;
import com.aliyuncs.exceptions.ClientException;
import com.aliyuncs.http.MethodType;
import com.aliyuncs.profile.DefaultProfile;
import com.aliyuncs.profile.IClientProfile;
import com.google.common.collect.ImmutableMap;
import com.storlead.sms.constants.SmsTemplateConstants;
import com.storlead.sms.exception.SMSException;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.map.HashedMap;
import org.apache.commons.lang3.StringUtils;

import java.util.HashMap;
import java.util.Map;


/**
 * 短信工具类
 *
 * @author blank
 * @since 2018/5/17 上午11:11
 */
@Slf4j
public class SmsUtil {

    /**
     * 转账对象为 json 字符串
     *
     * @param obj 要转换的对象
     * @return 转换后的 json 字符串
     */
    private static String mapToJSONString(Object obj) {
        return JSON.toJSONString(obj);
    }

    /**
     * 发送手机验证码短信
     *
     * @param mobile    手机
     * @param checkCode 验证码
     */
    public static boolean sendCheckCode(String mobile, Integer checkCode) throws ClientException,SMSException {
        return sendSms(SmsTemplateConstants.SMS_CHECK_CODE_TEMPLATE, mapToJSONString(ImmutableMap.of("number", checkCode)), mobile);
    }

    /**
     * 通过阿里短信向指定手机发送指定模板 ID 的短信
     *
     * @param templateCode  短信模板 ID
     * @param templateParam 短信模板参数
     * @param phoneNum      短信发送手机号
     * @return true 短信接口请求成功(!不是发送结果 是否成功 发送结果需要重新写短信发送查询接口来查询) / false 短信接口请求失败
     * @author blank 2017/10/30 上午11:31
     */
    public static boolean sendSms(String templateCode, String templateParam, String phoneNum) throws ClientException,SMSException {

        if (!StringUtils.isEmpty(templateParam)) {
            Map<String, Object> strMap = JSON.parseObject(templateParam, HashMap.class);
            strMap.forEach((k,v)->{
                String temp = v.toString();
                if (StringUtils.isNotBlank(temp)) {
                    if (temp.length() > 20) {
                        String s  = temp.substring(0, 18) + "..";
                        strMap.put(k, s);
                    }
                }
            });
            templateParam = JSON.toJSONString(strMap);
        }
        //设置超时时间-可自行调整
        System.setProperty("sun.net.client.defaultConnectTimeout", "10000");
        System.setProperty("sun.net.client.defaultReadTimeout", "10000");
        //初始化ascClient需要的几个参数
        //短信API产品名称（短信产品名固定，无需修改）
        final String product = "Dysmsapi";
        //短信API产品域名（接口地址固定，无需修改）
        final String domain = "dysmsapi.aliyuncs.com";
        //替换成你的AK
        //        final String accessKeyId = mns_accesskeyid;//你的accessKeyId,参考本文档步骤2
        //        final String accessKeySecret = mns_accesskeysecret;//你的accessKeySecret，参考本文档步骤2
        //初始化ascClient,暂时不支持多region（请勿修改）
        IClientProfile profile = DefaultProfile.getProfile("cn-hangzhou", SmsTemplateConstants.SMS_ACCESS_KEY, SmsTemplateConstants.SMS_ACCESS_KEY_SECRET);
        DefaultProfile.addEndpoint("cn-hangzhou", "cn-hangzhou", product, domain);
        IAcsClient acsClient = new DefaultAcsClient(profile);
        //组装请求对象
        SendSmsRequest request = new SendSmsRequest();
        //使用post提交
        request.setMethod(MethodType.POST);
        //必填:待发送手机号。支持以逗号分隔的形式进行批量调用，批量上限为1000个手机号码,批量调用相对于单条调用及时性稍有延迟,验证码类型的短信推荐使用单条调用的方式
        request.setPhoneNumbers(phoneNum);
        //必填:短信签名-可在短信控制台中找到
        request.setSignName("领存技术");
        //必填:短信模板-可在短信控制台中找到
        request.setTemplateCode(templateCode);
        //可选:模板中的变量替换JSON串,如模板内容为"亲爱的${name},您的验证码为${code}"时,此处的值为
        //友情提示:如果JSON中需要带换行符,请参照标准的JSON协议对换行符的要求,比如短信内容中包含\r\n的情况在JSON中需要表示成\\r\\n,否则会导致JSON在服务端解析失败
//        request.setTemplateParam("{\"store\":\"Tom\", \"code\":\"123\"}");
        request.setTemplateParam(templateParam);
        //可选-上行短信扩展码(扩展码字段控制在7位或以下，无特殊需求用户请忽略此字段)
        //request.setSmsUpExtendCode("90997");
        //可选:outId为提供给业务方扩展字段,最终在短信回执消息中将此值带回给调用者
//        request.setOutId("callback");
        //请求失败这里会抛ClientException异常
        SendSmsResponse sendSmsResponse = acsClient.getAcsResponse(request);
        if (sendSmsResponse.getCode() != null && "OK".equals(sendSmsResponse.getCode())) {
            //请求成功
            log.info("短信发送成功 对应模板 ID ----> {}, 对应手机---> {}", templateCode, phoneNum);
            return true;
        } else {
            throw new SMSException("短信发送失败:" + sendSmsResponse.getMessage());
//            log.error("短信发送失败 " + sendSmsResponse.getMessage());
//            return false;
        }

    }


    /**
     * @param userName    订单通知的用户
     * @param mobile      订单通知的手机号码
     * @param orderNumber 订单号
     * @param duetime     尾款最后支付时间
     * @Author: timo
     * @Date: 2018/11/25 17:48
     * @Description: 客户尾款支付提醒
     * <p>
     *
     * 模版类型: 短信通知
     * 模版名称: 客户尾款支付提醒
     * 模版CODE: SMS_152513457
     * 模版内容: 尊敬的${usename}，尾号为${ordernumber}的订单已完成生产，请您在${duetime}内支付尾款。领存将在尾款到账后发货。
     * 申请说明: 通知用户支付尾款
     *
     */
    public static void leftAmtPaymentSmsNotice(String userName, String mobile, String orderNumber, String duetime) throws ClientException, SMSException {
        Map<String, String> paramMap = new HashedMap<>();
        paramMap.put("usename", userName);
        paramMap.put("ordernumber", orderNumber.substring(orderNumber.length() - 4));
        paramMap.put("duetime", duetime+"天");
        sendSms("SMS_152513457", JSON.toJSONString(paramMap), mobile);
    }

    public static void main(String[] args) {
        try {
            sendSms(SmsTemplateConstants.SMS_CHECK_CODE_TEMPLATE, mapToJSONString(ImmutableMap.of("number", 123456)), "18118724055");
            String s = "11112222333344445555";
            System.out.println(s.substring(0,18));

        } catch (Exception e) {
            e.printStackTrace();
        }
    }


}
